//****************************************************************************
//                         File module_test_html_mail.c
//
//          Sendmail Milter Agent Interface Module (internal filter)
//
//    Copyright (c) Dmitry V. Stefankov, 2005. All rights reserved.
//
//****************************************************************************
//
//   $Source: /root/projects/tpmail/milter-agent/RCS/module_test_html_mail.c,v $
//  $RCSfile: module_test_html_mail.c,v $
//   $Author: dstef $
//     $Date: 2005-06-10 04:39:56+04 $
// $Revision: 1.2 $
//   $Locker: root $
//
//      $Log: module_test_html_mail.c,v $
//      Revision 1.2  2005-06-10 04:39:56+04  dstef
//      Fixed a bug with search of pattern in line
//
//      Revision 1.1  2005-04-21 16:40:58+04  dstef
//      Initial revision
//
//****************************************************************************


#include  <sys/types.h>
#include  <sys/socket.h>
#include  <unistd.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <errno.h>
#include  <time.h>
#include  <sys/stat.h>


#include  "module.h"


/*------------------------------ Global data -------------------------------*/

const char  SEARCH_PATTERN_1[] = "Content-type: text/html";
const char  SEARCH_PATTERN_2[] = "Content-Type: multipart/mixed";
const char  SEARCH_PATTERN_3[] = "Content-Type: application";


/*-------------------------------- Local data ------------------------------*/
const char  rcsid[] = "$Id: module_test_html_mail.c,v 1.2 2005-06-10 04:39:56+04 dstef Exp root $";


/*----------------------------- Functions prototypes -----------------------*/



int  process_message_by_module( char * parameters )
{
    int  result = -1;
    int  len;
    int  attachments_flag = 0;
    int  html_mail_flag = 0;
    FILE * fp;
    char buf[2048];
    
    if ((parameters == NULL) || (*parameters == '\0')) return (result);
    
    fp = fopen( parameters, "rt" );
    if (fp == NULL) {
        result = -2;
	return(result);
    }
    
    result = 0;
    
    while( fgets(buf,sizeof(buf),fp) != NULL) {
         len = strlen(buf);
         if (len < 2) continue;
	 
	 if (strncasecmp(buf,SEARCH_PATTERN_1,sizeof(SEARCH_PATTERN_1)-1) == 0) {
	     html_mail_flag = 1;
	     result = 1;
	     break;
	 }

	 if (strncasecmp(buf,SEARCH_PATTERN_2,sizeof(SEARCH_PATTERN_2)-1) == 0) {
	     attachments_flag = 1;
	     continue;
	 }

         if (attachments_flag) {
            if (strncasecmp(buf,SEARCH_PATTERN_3,sizeof(SEARCH_PATTERN_3)-1) == 0) {
               result = 1;
               break;
            }
         }
    }
    
    fclose(fp);
    
    return(result);
}
